Attribute VB_Name = "ProgramCode"
Option Explicit

Public strChatText As String
Public strSName As String

Public intUsed(0 To 16383) As Integer

Public intPingOutNum As Integer
Public strPingOut(1 To 50) As String
Public intPingInNum As Integer
Public strPingIn(1 To 50) As String

Public conNPre As String
Public conRTF As String * 1
Public conCR As String * 2
Public conBoldOn As String * 2
Public conBoldOff As String * 2
Public Const conAll As String = "all"
Public Const conTx As String = "TX"
Public Const conRx As String = "RX"

Public Sub Main()
    
    Randomize Timer
    
    With frmPChat
        .lblLocalIP.Caption = .udpIO.LocalIP
        .udpIO.Bind .udpIO.LocalPort
    End With
        
    conRTF = Chr(30)
    conCR = conRTF + "c"
    conBoldOn = conRTF + "b"
    conBoldOff = conRTF + "r"
    conNPre = conRTF + "0" + conBoldOn + ">>> " + conBoldOff

    ClearChat
       
    Dim intN As Integer
    For intN = 0 To 16383
        intUsed(intN) = -1
    Next intN

    frmPChat.Show
End Sub

Public Function CheckIP(what As String) As Boolean
    Dim blnIsIn As Boolean
    Dim intN As Integer
           
    blnIsIn = False
    
    With frmPChat.lstIPs
        For intN = 0 To .ListCount - 1
            If .List(intN) = what Then blnIsIn = True
        Next intN
    End With
    
    CheckIP = blnIsIn
End Function

Public Sub AddIP(strWhat As String)
    If CheckIP(strWhat) = False Then
        frmPChat.lstIPs.AddItem strWhat
    End If
End Sub

Public Sub DelIP(strWhat As String)
    Dim intN As Integer
    
    With frmPChat.lstIPs
        For intN = 0 To .ListCount - 1
            If .List(intN) = strWhat Then .RemoveItem (intN)
        Next intN
    End With
End Sub

Public Sub SendMsg(strWhere As String, strWhat As String)
    Light conTx, True
    On Error GoTo Errr
    
    With frmPChat
        If strWhere = conAll Then
            Dim intN As Integer
            For intN = 0 To .lstIPs.ListCount - 1
                .udpIO.RemoteHost = .lstIPs.List(intN)
                .udpIO.SendData strWhat
            Next intN
        Else
            .udpIO.RemoteHost = strWhere
            .udpIO.SendData strWhat
        End If
    End With

    On Error GoTo 0
    Light conTx, False
    Exit Sub

Errr:
    If Err = 10014 Then Resume Next
    If Err = 10049 Then Resume Next
    If Err = 10050 Then Resume Next
    If Err = 126 Then Resume Next
    Light conTx, False
    Error Err
End Sub

Public Function MakeHead() As String
    Dim intN As Integer
    Dim intRndNum As Integer

    Do
        intRndNum = Int(Rnd * 16384)
    Loop Until intUsed(intRndNum) = -1

    MakeHead = Chr(Int(intRndNum / 128) + 128) + Chr((intRndNum Mod 128) + 128)

End Function

Public Function DecodeHead(strWhat As String) As Integer
    DecodeHead = ((Asc(Mid(strWhat, 1, 1)) - 128) * 128) _
        + (Asc(Mid(strWhat, 2, 1)) - 128)
End Function

Public Sub PingIPs()
    
    Dim intN As Integer
    Dim intM As Integer
    Dim blnGotRsp As Boolean
    Static blnPingOrNot As Boolean
        
    blnPingOrNot = Not blnPingOrNot
    
    
' --- Check for Received Pings (Every 2 Cycles) ---
    If blnPingOrNot Then
    
        For intN = 1 To intPingOutNum
            blnGotRsp = False
            
            For intM = 1 To intPingInNum
                If strPingIn(intM) = strPingOut(intN) Then blnGotRsp = True
            Next intM
            
            If blnGotRsp = False Then DelIP (strPingOut(intN))
        Next intN

' --- Make New IP List (Every 2 Cycles) ---
        
        For intN = 1 To intPingInNum
            strPingIn(intN) = ""
        Next intN
        
        intPingInNum = 0
        
        With frmPChat.lstIPs
            intPingOutNum = .ListCount
            For intN = 1 To intPingOutNum
                strPingOut(intN) = .List(intN - 1)
            Next intN
        End With
    
    End If

' --- Send Pings if Not Received Yet (Every Cycle) ---
    For intN = 1 To intPingOutNum
        If GotPing(strPingOut(intN)) = False Then SendMsg strPingOut(intN), "po"
    Next intN

End Sub

Public Sub Add2rtf(txt As String)
    
    Dim strRTFOut As String

    txt = RTFcleanUp(txt)
    
    strChatText = strChatText + txt
    strRTFOut = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl\f0\fnil\fprq2\fcharset0 Arial;}{\colortbl\red0\green0\blue0;\red255\green0\blue0;\red0\green0\blue255;\red128\green0\blue0;\red0\green128\blue0;\red0\green128\blue128;\red0\green0\blue128;\red128\green0\blue128;}\f0\fs18\cf0\b0 "
       
    Dim intN As Integer
    
    If Len(strChatText) > 2000 Then strChatText = Right(strChatText, 2000)
    
    For intN = 1 To Len(strChatText)
    If Mid(strChatText, intN, 1) = conRTF Then
        intN = intN + 1
        Select Case Mid(strChatText, intN, 1)
            Case "b": strRTFOut = strRTFOut + "\b "
            Case "r": strRTFOut = strRTFOut + "\b0 "
            Case "c": strRTFOut = strRTFOut + "\par "
            Case "0": strRTFOut = strRTFOut + "\cf0 "
            Case "1": strRTFOut = strRTFOut + "\cf1 "
            Case "2": strRTFOut = strRTFOut + "\cf2 "
            Case "3": strRTFOut = strRTFOut + "\cf3 "
            Case "4": strRTFOut = strRTFOut + "\cf4 "
            Case "5": strRTFOut = strRTFOut + "\cf5 "
            Case "6": strRTFOut = strRTFOut + "\cf6 "
            Case "7": strRTFOut = strRTFOut + "\cf7 "
            Case "8": strRTFOut = strRTFOut + "\cf8 "
            Case "9": strRTFOut = strRTFOut + "\cf9 "
        End Select
    Else
        strRTFOut = strRTFOut + Mid(strChatText, intN, 1)
    End If
    Next intN
        
    strRTFOut = strRTFOut + "}"
    
    frmPChat.txtChat.TextRTF = strRTFOut
End Sub

Public Function nCol(typ As Integer) As String
    Dim intN As Integer
    For intN = 0 To 7
        If frmColor.optNColor.Item(intN).Value = True Then
            If typ Then
                nCol = frmColor.optNColor.Item(intN).BackColor
            Else
                nCol = conRTF + Trim(Str(intN))
            End If
            Exit Function
        End If
    Next intN
End Function

Public Function mCol(typ As Integer) As String
    Dim intN As Integer
    For intN = 0 To 7
        If frmColor.optMColor.Item(intN).Value = True Then
            If typ Then
                mCol = frmColor.optMColor.Item(intN).BackColor
            Else
                mCol = conRTF + Trim(Str(intN))
            End If
            Exit Function
        End If
    Next intN
End Function

Public Function GotPing(theIP)
    Dim intN As Integer
    Dim isThere As Boolean
    isThere = False

    For intN = 1 To intPingInNum
        If strPingIn(intN) = theIP Then isThere = True
    Next intN

    GotPing = isThere
End Function

Public Sub PingRecv(fromIP As String)
    If GotPing(fromIP) = False Then
        intPingInNum = intPingInNum + 1
        strPingIn(intPingInNum) = fromIP
    End If
End Sub

Public Function RTFcleanUp(what As String) As String
    Dim strOut As String
    Dim strCChr As String * 1

    Dim intN As Integer
    For intN = 1 To Len(what)
        strCChr = Mid(what, intN, 1)
        If InStr("{}\;", strCChr) <> 0 Then strOut = strOut + "\"
        strOut = strOut + strCChr
    Next intN

    RTFcleanUp = strOut
End Function

Sub ClearChat()
    strChatText = ""
    Add2rtf (conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR + conCR)
    frmPChat.cmdClear.Enabled = False
End Sub

Sub Light(strTR As String, blnOnOff As Boolean)
    Dim lngOnOff(True To False) As Long
    lngOnOff(True) = &HFF00&
    lngOnOff(False) = &H808080
    
    Select Case strTR
        Case conTx
            frmPChat.lblTxRx(0).BackColor = lngOnOff(blnOnOff)
        Case conRx
            frmPChat.lblTxRx(1).BackColor = lngOnOff(blnOnOff)
    End Select
    DoEvents
End Sub
